
// 08-02-2024 modif affectation RC3 RC4 to I2C
// 24-03-2023
//rajout definitions parametres OLED

// 18-03-2023
#include <xc.h>
#define _XTAL_FREQ 64000000

#ifndef Word
#define Word uint16_t
#endif

#ifndef Byte
#define Byte uint8_t
#endif

#define CR 13
#define LF 10
#define TAB 9

#define Led_R_Dir TRISAbits.TRISA4
#define Led_R     LATAbits.LATA4
#define SQA_Dir   TRISAbits.TRISA3
#define SQA       LATAbits.LATA3

#define _RB0        LATBbits.LATB0
#define _CS         LATBbits.LATB1
#define _RST        LATBbits.LATB2
#define _DC         LATBbits.LATB3            // repere A0 sur GC9A01 Rouge

#define _CS_Dir     TRISBbits.TRISB1
#define _RST_Dir    TRISBbits.TRISB2
#define _DC_Dir     TRISBbits.TRISB3

#define _RC2        LATCbits.LATC2  
#define _RC2_Dir    TRISCbits.TRISC2  

#define SQA_Dir  TRISAbits.TRISA3
#define SQA      LATAbits.LATA3

#define SCL         LATCbits.LATC3
#define SData       LATCbits.LATC5
#define MISO        PORTCbits.RC4


#define SCL_Dir         TRISCbits.TRISC3
#define SData_Dir       TRISCbits.TRISC5
#define MISO_Dir        TRISCbits.TRISC4

#define Cde 0
#define Donnee 1

//   OLED parameter definitions

#define GC9A01A_NOP     0x00
#define GC9A01A_SWRESET 0x01    //  Software reset register
#define GC9A01A_RDDID   0x04    //  Read display identification information
#define GC9A01A_RDDST   0x09    //  Read Display Status

#define GC9A01A_SLPIN 0x10      //  Enter Sleep Mode
#define GC9A01A_SLPOUT 0x11     //  Sleep Out
#define GC9A01A_PTLON 0x12      //  Partial Mode ON
#define GC9A01A_NORON 0x13      //  Normal Display Mode ON

#define GC9A01A_RDMODE  0x0A
#define GC9A01A_RDMADCTL  0x0B
#define GC9A01A_RDPIXFMT  0x0C
#define GC9A01A_RDIMGFMT  0x0D
#define GC9A01A_RDSELFDIAG  0x0F

#define GC9A01A_INVOFF 0x20     //  Display Inversion OFF
#define GC9A01A_INVON 0x21      //  Display Inversion ON
//#define ILI9341_GAMMASET 0x26 //  Gamma Set
#define GC9A01A_DISPOFF 0x28    //  Display OFF
#define GC9A01A_DISPON 0x29     //  Display ON

#define GC9A01A_CASET 0x2A      //  Column Address Set
#define GC9A01A_PASET 0x2B      //  Page Address Set
#define GC9A01A_RAMWR 0x2C      //  Memory Write
#define GC9A01A_RAMRD 0x2E


#define GC9A01A_PTLAR 0x30    //  Partial Area
#define GC9A01A_VSCRDEF 0x33  //  Vertical Scrolling Definition
#define GC9A01A_TEOFF 0x34    //  Tearing effect line off
#define GC9A01A_TEON 0x35     //  Tearing effect line on
#define GC9A01A_MADCTL 0x36   //  Memory Access Control
#define GC9A01A_VSCRSADD 0x37 //  Vertical Scrolling Start Address
#define GC9A01A_PIXFMT 0x3A   //  COLMOD: Pixel Format Set
// 0x3C = Write memory continue
// 0x44 = Set tear scanline
// 0x45 = Get scanline
// 0x51 = Write display brightness
// 0x53 = Write CTRL display


// bits choix orientations
#define MADCTL_MY 0x80    //  Bottom to top
//#define MADCTL_MX 0x40  //  Right to left
#define MADCTL_MX 0x0     //   left to Right
#define MADCTL_MV 0x20    //  Reverse Mode
#define MADCTL_ML 0x10    //  LCD refresh Bottom to top
#define MADCTL_RGB 0x00   //  Red-Green-Blue pixel order
#define MADCTL_BGR 0x08   //  Blue-Green-Red pixel order
#define MADCTL_MH 0x04    //  LCD refresh right to left
//#define MADCTL_MH 0x00  //  LCD refresh right to left
 // 0x3C = Write memory continue
// 0x44 = Set tear scanline
// 0x45 = Get scanline
// 0x51 = Write display brightness
// 0x53 = Write CTRL display
// 0xA7 = Vcore voltage control
// 0xB0 = RGB interface signal control
// 0xB1 ///< Frame Rate Control (In Normal Mode/Full Colors)
// 0xB3 ///< Frame Rate control (In Partial Mode/Full Colors)



#define GC9A01A_FRMCTR1 0xB1   // Frame Rate Control (In Normal Mode/Full Colors)
#define GC9A01A_FRMCTR2 0xB2   // Frame Rate Control (In Idle Mode/8 colors)
#define GC9A01A_FRMCTR3 0xB3   //  Frame Rate Control (In Idle Mode/8 colors)
#define GC9A01A_INVCTR  0xB4
// 0xB5 = Blanking porch control
#define GC9A01A_DFUNCTR 0xB6   // Display Function Control

// 0xC1 = Power criterion control

#define GC9A01A_PWCTR1  0xC0   // Power Control 1
#define GC9A01A_PWCTR2  0xC1
#define GC9A01A_PWCTR3  0xC2
#define GC9A01A1_VREG1A 0xC3
#define GC9A01A_PWCTR4  0xC3   // Vreg1a voltage control 4
#define GC9A01A1_VREG1B 0xC4
#define GC9A01A_PWCTR5  0xC4   // Vreg1b voltage control 5
#define GC9A01A_VMCTR1  0xC5   // VCOM Control 1
#define GC9A01A_VMCTR2  0xC7   // VCOM Control 1
#define GC9A01A1_VREG2A 0xC9   // Vreg2a voltage control

#define GC9A01A_RDID1   0xDA   // Read ID 1
#define GC9A01A_RDID2   0xDB
#define GC9A01A_RDID3   0xDC
#define GC9A01A_RDID4   0xDD

#define GC9A01A_GMCTRP1 0xE0
#define GC9A01A_GMCTRN1 0xE1

#define GC9A01A_FRAMERATE 0xE8 ///< Frame rate control

#define GC9A01A_INREGEN2 0xEF // Inter register enable 2
#define GC9A01A_GAMMA1 0xF0   // Set gamma 1
#define GC9A01A_GAMMA2 0xF1   // Set gamma 2
#define GC9A01A_GAMMA3 0xF2   // Set gamma 3
#define GC9A01A_GAMMA4 0xF3   // Set gamma 4
#define GC9A01A_INREGEN1 0xFE ///< Inter register enable 1

