#define VERSION "2024-0210"
//#define VERSION "2023-1116"
// modif  fontes
//#define VERSION "2023-1114"
// usage OLED CG9A01 en 3,3V ! liaison SPI 
// avec lecteur RFID SPI (aliment en 3,3V)
// usage de malloc et Heap pour stocker les fontes
// voir version MikroC OK 
// PIC18F27K42_OLED_GC9A01_SPI_Bit_Bang_Image_65Kc_240x232_MC_2023-0315.c
//#define VERSION "2022-0322"

// voir ligne 174  //       value = SPI1_Read_Byte( 0x00 );

// SPI clock  32MHz et revision Ecran_Noir
//#define VERSION "2022-0322"
// SPI clock  16MHz

// voir OLED GC9A01 et SPI Hardw 18F27K42
// https://fantaspic.fr/viewtopic.php?f=10&t=1292&start=30


#include "xc.h"

#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>
#include <stdio.h>
#include "Config.c"
//#include <conio.h>


#define COMPILO "XC8 V2.36 C99"
#define PACK "PIC18F-K_DFP 1.6.125"
#define UART1_RX_BUFFER_SIZE 128  
#define BR        115200       // Baud Rate  UART Speed !!!!
#define BRG       ((FCY/BR)-1) // brgs=1

#define Directory "C:\\MPLABX_Projects"
#define Project " _18F27k42_OLED_SPI_Hw_CG9A01_2024-02.X"
#define Source  " main.c, Config.c, Init_GC9A01.c"
#define Devices " OLED LCD ROND 240x240 SPI CG9A01\r\n"
#define Eeprom " not used ...."
#define Config " Fosc_Interne 64Mhz "
#define Others " Defines_data_2024-02.h, Init_GC9A01.h  TFT_6_Fonts_CG9A01.h\r\n RGB_colors.h, Daffy_Duck_Bmp.h\r\n"

#define MCU "18F27K42"
#define POWER_SUPPLY  " 3.3V"
#define FOSC " Interne 16x4 =64.0"  // MHz
#define BAUD 115200                // UART1

//#define With_BMP       // pour gros fichier image en Flash rom!    
#define With_SPI_Hardware 

/*modele Rouge sur platine rectangulaire
1,28" SPI 240x240  8 pins
8 Vcc
7 Gnd
6 CS -----> CS/            RB0
5 RES -----> RST/		   RB1	
4 DC-A0 Donne=1/Cde=0      RB2
3 SDA ------> MOSI		   RC5	
2 SCK -------> SCK         RC3
1 LED --------> LED
                           RC4  MISO
avec porte carte SD au dos du module (5 pins TF card)
*/
#include "Defines_datas_2024-0211.h"
#include "RGB_colors.h"
#include "Init_GC9A01.h"
#include "TFT_6_Fonts_CG9A01.h"
//#include "LadyBug_.h"   // trop grande !!! 
#include "Daffy_Duck_Bmp.h"     // image 120x120 N&B duck_120_bitmap OK


// nota pin LED OLED relie au +VCC via R=2,7K
#define GC9A01A_TFTWIDTH  240
#define GC9A01A_TFTHEIGHT 240
#define Max_Lcd_Buff 240*240

#pragma warning disable 1498
#pragma warning disable 31
#pragma warning disable 228   // caractere francais accentu
#pragma warning disable 520  
#pragma warning disable 1510 
#pragma warning disable 759
#pragma warning disable  2053
#pragma warning disable  2020
#pragma warning disable 359
#pragma warning disable 373



/*
 * HARDWARE :

#define Led_R     LATAbits.LATA4
#define SQA      LATAbits.LATA3
 * 
#define _RC2        LATCbits.LATC2  
#define _CS         LATBbits.LATB1
#define _RST        LATBbits.LATB2
#define _DC         LATBbits.LATB3    // A0 sur modele rouge

#define SCL         LATCbits.LATC3
#define SData       LATCbits.LATC5
#define MISO        PORTCbits.RC4

  */

#define MAX_LEN1 128
//volatile __uint24   SMT1TMR  __at(0x3F12);

unsigned long SMT1_Measure;
unsigned  char *ST;
unsigned long  L1=0;
unsigned long  L2=0;

uint16_t  i,j,k,l,m,n;
uint16_t  Rep;
uint8_t  c1,c2,c3,cx,cc;
uint8_t  temp=0;
volatile uint8_t Buffer1[UART1_RX_BUFFER_SIZE];
volatile uint16_t Index1,i1;
volatile uint8_t Flag_Buffer1=0;
char Bavard=0;

uint8_t TEXTE [128];
uint8_t * txt;
uint8_t * p0;
const uint8_t * p1;
const uint8_t * p2;
uint8_t * px;
uint8_t CRam1[80];

float F0,F1,F2;

uint32_t  SPI_SPEED=0;
// compteur Timers
volatile uint16_t Count0, Count1 ;
volatile uint16_t Cpt0, Cpt1,Cpt2;;
volatile uint16_t Flag_Timer1=0;
volatile uint16_t Flag_Timer2=0;
volatile uint16_t Flag_Timer6=0;
volatile signed int  Cpt6;  
char Status_GIE_Bit;
char Etat_SPI;

#define Max_Lcd_Buff  240*240    // 57600
#define GC9A01A_TFTWIDTH 240
#define GC9A01A_TFTHEIGHT 240

 unsigned char Buffer_Font[MAX_LEN1];
//char TABLE_FONTE[2410];  // taille 2405 trebuchet

static int _maxX ;
static int _maxY;
static int _width, _height;

static unsigned int Color,bgColor,textColor,textBgcolor;
//Word Couleur[8]; //=COLOR_WHITE,COLOR_BLUE,COLOR_GREEN,COLOR_YELLOW,COLOR_RED,COLOR_MAGENTA,COLOR_BRAUN,COLOR_TURQUOISE;

static unsigned char  Orientation;
int Step=0;
unsigned char dummy[32];
volatile char * pp;
volatile signed  int  * pE;
//unsigned int km=0;
int Font_Active=1;
//signed int Mu;
//int Flash_Data[32];
// cfont.width=6   cfont.height=8   cfont.offset = 0x20=SPACE   cfont.numchars= 96  25 chars/ligne, taille fonte integer sur 2 bytes  + 1byte dummy
// FONT_HEADER_SIZE 8
//const char TerminaL6x8[]  = {  // 96 chars * 7
// 96 lignes de 7 bytes => 672    + header de 8 bytes => 680
// 0x06, 0x08, 0x20, 96, 40 ,0x02,0xA8,0x00,  //    0x28=40 cars par ligne, 0x02A0=672 +8 =   rev 13/11/2023
 struct _currentFont
 {
    unsigned char * font;
    Byte width;
    Byte height;
    Byte offset;
    Byte numchars;  // Nb de cars definis
    unsigned char MaxC; // nb max de cars par ligne
    Byte nbrows; 
    uint16_t Taille        ;
    Byte dummy;
  } cfont;


volatile struct Anybits {   // 8 flags
       unsigned  Tmr0_Elapsed:1;     // for timer0 16bits
       unsigned  Tmr1_Elapsed:1;     // for timer1 16bits
       unsigned  Tmr2_Elapsed:1;     // for timer2 8bits
       unsigned  Tmr3_Elapsed:1;     // for timer3 16bits
       unsigned  Tmr4_Elapsed:1;     // for timer4 8bits
       unsigned  Tmr6_Elapsed:1;     // for timer6 8bits
       unsigned  NCO_initialise:1;   // for NCO
       unsigned  libre:1;
 }Drapeaux ;
 
void Init_Hardware(void) ;
void Interrupt_Init(void);
void  UART1_Init(void); 
void TMR6_Init_500ms(char N);
void RAZ_UART1_Buffer1(void);
void PrintChar(uint8_t txData);
void Print (char * T1);
void CPrint (const char * T1);
void CRLF1(void);
void strConstRamCpy(uint8_t  *dest, const  uint8_t *source);
void __delay_xSec(unsigned char N);

void SetWindow(uint16_t x1, uint16_t  y1, uint16_t  x2, uint16_t  y2);
void Init_CG9A01(void);
void Draw_CText(uint16_t x,uint16_t y,const unsigned char *T,uint16_t Co);
void DrawText(uint16_t x, uint16_t y, unsigned char * s, uint16_t color);
unsigned char DrawChar(int x, int y, Byte ch, Word color);
void Param_Font(void);
void Select_Font_Type(int Type);
//void Close_Font_Type(int Type);
void Put_Big_Pixel(int x1,int y1,uint16_t color);
void Put_Pixel(int x1,int y1,uint16_t color);
void Draw_Line( int x_start, int y_start, int x_end, int y_end, int color);
void Rectangle_Plein(int x1,int y1, int x2,int y2,Word color);
void Clear_LCD(void);
void DrawBitMap(int, int y, const char *bitmap, int  w, int h, Word color);


#define START_SMT1  SMT1_Measure=0; ST=&SMT1_Measure;SMT1STATbits.RST=1; SMT1CON1bits.SMT1GO=1;  
#define STOP_SMT1  *(ST)=SMT1TMRL; *(ST+1)=SMT1TMRH;*(ST+2)=SMT1TMRU;*(ST+3)=0;
void SMT1_Init(char Choix_SMT1_Clock); // clock 64MHz,16Mhz,500Khz,31,25Khz
void Start_SMT1(void);
void Stop_SMT1(void);

#ifdef With_SPI_Hardware
void My_Init_SPI1(void);
Byte  SPI1_WriteByte(uint8_t bb);
void SendCmd  ( uint8_t c) ;
void SendData ( uint8_t c); 
#endif

void  Interrupt_Init(void)
{
    char state=0;
    if (INTCON0bits.GIE == 1) state=1;
    INTCON0bits.GIE=0;

    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x00; // unlock IVT

    IVTBASEU = 0;
    IVTBASEH = 0;
    IVTBASEL = 8;

    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x01; // lock IVT

    // Assign peripheral interrupt priority vectors
    IPR3bits.U1RXIP = 1;
 //   IPR1bits.INT0IP = 1;
 //   IPR4bits.TMR1IP = 1;
    IPR9bits.TMR6IP = 0;
  //  IPR7bits.TMR4IP = 0;
  //  IPR0bits.IOCIP=1;
    if (state>0) INTCON0bits.GIE = 1;
}


void __interrupt(irq(IRQ_U1RX),high_priority) UART1_rx_vect_isr(void)
{
   static char cx;
  //  U1TXB='H';  // pour debugging only
  if ( (PIR3bits.U1RXIF==1) && (PIE3bits.U1RXIE ==1) )
  {   
      c1=U1RXB;
   //   U1TXB='*'; // echo
     if ((c1==13) || (i1>UART1_RX_BUFFER_SIZE-1))
     { 
      Flag_Buffer1=1;
      Buffer1[i1]=0;
      Index1=i1;
      i1=0; 
     PIE3bits.U1RXIE =0;
     }
     else
     {
       Buffer1[i1]=c1;
       i1++;
       Index1=i1;
      } 
   } 
}

void __interrupt(irq(IRQ_TMR6),low_priority) TMR6_ISR(void)
{  
    if ( (TMR6IE==1) && (TMR6IF==1) )
    {
      if (Cpt6>1)  // decomptage maxi 32767
       {
         Cpt6--;
        }
      else
      {
        Drapeaux.Tmr6_Elapsed=1;
        TMR6IE=0;
      } 
     Flag_Timer6=1;
     TMR6IF=0;// clear the TMR6 interrupt flag
    }       
 }

void Timer2_OFF()
{
  Flag_Timer2=0;
   PIE4bits.TMR2IE=0;
   PIR4bits.TMR2IF=0;
   T2CONbits.T2ON=0;
} 

void Init_Timer2() //100mS  mS avec FOSC=500KHz 
{ 
  T2CON    = 0x00;
  //clock 
  T2CLK  =0x05;       //  5=500Khz   1= FOSC/4    2=FOSC
  // prescaler
  T2CONbits.CKPS2=1;//  5 => 1/32 
  T2CONbits.CKPS1=0;
  T2CONbits.CKPS0=1;
 //  T2CONbits.CKPS=3;
  T2CONbits.OUTPS=7;  // => div 1/32
  T2PR=194;  // 2 * 32  *8 * (194+1)  => 99840 S  soit~ 100 mS 
  T2TMR=0;
 // REGISTER 22-2: TxRST: TIMER2 EXTERNAL RESET SIGNAL SELECTION REGISTER p337
  T2RST=0x00;  
  Cpt2=0;
  Drapeaux.Tmr2_Elapsed=0;     
  Flag_Timer2=0;
  PIE4bits.TMR2IE=1;
  PIR4bits.TMR2IF=0;
  T2CONbits.T2ON=1;
}

//------------------------------------------------------
void __delay_xSec(unsigned char N)
{
static int i2;  
for (i2=0;i2<N;i2++)  __delay_ms(1000);
}

void UART1_Init(void)
{
    U1P1L = 0x00;
    U1P1H = 0x00;
    U1P2L = 0x00;
    U1P2H = 0x00;
    U1P3L = 0x00;
    U1P3H = 0x00;
    U1CON0 = 0xB0; // BRGS high speed; MODE Asynchronous 8-bit mode; RXEN enabled; TXEN enabled; ABDEN disabled; 
    // RXBIMD Set RXBKIF on rising RX input; BRKOVR disabled; 
    // WUE disabled; SENDB disabled; ON enabled; 
    U1CON1 = 0x80;    
    // TXPOL not inverted; FLO off; C0EN Checksum Mode 0; RXPOL not inverted;
    //RUNOVF RX input shifter stops all activity; STP Transmit 1Stop bit, receiver verifies first Stop bit; 
    U1CON2 = 0x00;
    U1BRGL = 0x8A; // BRGL 138;   115200 bds
    U1BRGH = 0x00; // BRGH 0; 
    U1FIFO = 0x00; // STPMD in middle of first Stop bit; TXWRE No error; 
    // ABDIF Auto-baud not enabled or not complete; 
    // WUIF WUE not enabled by software; ABDIE disabled; 
    U1UIR = 0x00;
    // ABDOVF Not overflowed; TXCIF 0; RXBKIF No Break detected; 
    // RXFOIF not overflowed; CERIF No Checksum error; 
    U1ERRIR = 0x00;
    // TXCIE disabled; FERIE disabled; TXMTIE disabled; ABDOVE disabled;
    // CERIE disabled; RXFOIE disabled; PERIE disabled; RXBKIE disabled; 
    U1ERRIE = 0x00;
    U1CON0bits.TXEN=1;
    U1CON0bits.RXEN=1;  // enable recpetion
    PIE3bits.U1RXIE = 0;  // disable receive interrupt
}

void strConstRamCpy(uint8_t  *dest, const  uint8_t *source)
 { static uint8_t cc=0;
 cc= *(source);
  while ( cc>0 )
  { cc=*(source);
    *(dest++) =cc;
    source++ ;
  }
  *(dest) = 0 ;    // terminateur
}

void PrintChar( uint8_t txData)
{
    while(0 == PIR3bits.U1TXIF)
    {
        __asm("NOP");
    }
    U1TXB = txData;    // Write the data byte to the USART.
}

 void Print (char * Tc)
 { static uint16_t k;
   k=0;      
   while(*(Tc+k)>0) 
   {
     while(PIR3bits.U1TXIF==0);
     U1TXB=*(Tc+k);
    k++;
    if(k>128)break;
   }
}

  void CPrint (const char *T1)
 { 
   while(*(T1)>0) 
   {
     while(PIR3bits.U1TXIF==0);
     U1TXB=*(T1);
    T1++;
   }
}

void CRLF1(void)
{
   while(PIR3bits.U1TXIF==0);
   U1TXB=13;
    while(PIR3bits.U1TXIF==0);
   U1TXB=10;  
  }   

void RAZ_UART1_Buffer1(void)
{    
      if (PIR3bits.U1RXIF==1)   c1=U1RXB ;
      for (i1=0;i1<sizeof(Buffer1)-1;i1++) Buffer1[i1]=0;

      Flag_Buffer1 =0 ;
 
      U1ERRIR = 0x00;
      U1ERRIE = 0x00;
      Buffer1[0]=0;
      i1=0;
      Index1=0;
     c1=0;
      U1CON0bits.U1RXEN=1;
      PIE3bits.U1IE  = 1;       // int uart1 enabled
      PIE3bits.U1RXIE =1;  
} 

void TMR6_Init_500ms(char N)
{   
    //  cycle=500 mS modifi -> 1sec !
    
     TMR6ON = 0;
     PIE9bits.TMR6IE=0 ;
     TMR6IF=0;
     // T2PSYNC Not Synchronized; T2MODE Software control; T2CKPOL Rising Edge; T2CKSYNC Not Synchronized; 
    T6CLKCON = 0x05;    // T2CS FOSC/4 ou    0x05 pour 500Khz
    T6HLT = 0x00;
    T6TMR = 0x00;  // TMR4 0; 
    T6CON = 0x70 | 0x07 ; // Prescaler =7=> 1/128 Poscaler=7=>  1/8 =>  ticks= 512  S
    T6PR=244;   // 512 * (244+1) * 128 * 8 => 501760S ->  500mS sec
    Flag_Timer6=0;
    Drapeaux.Tmr6_Elapsed=0;
 
   TMR6IF=0;
   if(N>0) 
   { 
     Cpt6=N;
      PIE9bits.TMR6IE=1 ;  // TMR6IE_bit=1;
   }
   else
   {
       PIE9bits.TMR6IE=0 ; // TMR6IE_bit=0;
        Cpt6=1;      
   } 
 TMR6IF=0;   
 TMR6ON = 1;
 }




void SMT1_Init(char Choix_SMT1_Clock)
{ 
   //04-04-2021
     // registre  SMT1CON0
     SMT1CON0bits.SMT1EN =1;    // SMT enabled
     SMT1CON0bits.WPOL=0; // Window Polarity
     SMT1CON0bits.SPOL=0; // Signal Polarity
     SMT1CON0bits.CPOL=0; // Clock Polarity
     SMT1CON0bits.SMT1PS1=0; // PS<1:0>: SMT Prescale Select bits = 1/1
     SMT1CON0bits.SMT1PS0=0;    // 11=1/8  10=1/4  01=1/2 00=1/1
     SMT1CON0bits.SMT1EN =1;    // SMT enabled
     SMT1CON0bits.SMT1STP=0;    // 0 =reset 1=STOP; 
     SMT1CON1bits.SMT1GO=0;     // 1= suit l'entree   0=stop suivi
     SMT1CON1bits.SMT1REPEAT=0; // 0= Single  Acquisition   1=repeat mode
    // REGISTER 25-4: SMT1CLK: SMT CLOCK SELECTION REGISTER 16MHz
    // 000=FOSC/4    001=FOSC  010=HINTOSC 16MHz    101 = MFINTOSC/16 (32 kHz)
    //100 = MFINTOSC (500 kHz)
     if (Choix_SMT1_Clock<6)SMT1CLKbits.CSEL=Choix_SMT1_Clock;
    //  SMT1CLKbits.CSEL2=  1;   // 31,25Khz => tick=32S
    //  SMT1CLKbits.CSEL1=  0;
    //  SMT1CLKbits.CSEL0=  1;
	// 25.7.1 PW (Pulse Width) AND PR (Periode Read)  ACQUISITIONI NTERRUPTS
      PIR1bits.SMT1PRAIF=0;
      PIE1bits.SMT1PRAIE=0;
     //  25.7.2  PERIOD MATCHI NTERRUPT
      PIR1bits.SMT1IF=0;
      PIE1bits.SMT1IE=0;
      // init  compteur
      SMT1PRU=0xFF;
      SMT1PRH=0xFF;
      SMT1PRL=0xFF;
     // MODE de fonctionnement TIMER  page 396  
     //   0000=Timer   0100=windowed measure  1000=counter
     //SMT1CON1=0;
     SMT1CON1bits.MODE3=0;
     SMT1CON1bits.MODE2=0;
     SMT1CON1bits.MODE1=0;
     SMT1CON1bits.MODE0=0;
     SMT1CON0bits.SMT1EN =1;    // SMT enabled
  //   SMT1_Measure=0L;
  //   ST=&SMT1_Measure; // pointeur Byte sur debut entier long 32 bits

  }

void Init_Hardware()
{
    LATA = 0x00;
    ANSELA = 0x02;  // RA1 analog
    TRISA = 0xFF; 
  
    LATB = 0x00;
    ANSELB = 0x00;
    TRISB = 0b11000000;
 
    
    ANSELC = 0x00;
    TRISC = 0x80;
    LATC = 0x00;
       
    Led_R_Dir =0;
    Led_R =0;
    SQA_Dir =0;   
    SQA=0;
    _RB0=0;

    WPUE = 0x00;
    WPUB = 0xFF;
    WPUA = 0x00;
    WPUC = 0x80;

  
    /**
    ODx registers
    */
   //  ODCONC = 0x18; //I2C!
    ODCONC = 0x00;

    /**
    SLRCONx registers
    */
    SLRCONA = 0xFF;
    SLRCONB = 0xF0;
    SLRCONC = 0x80;  //// pas de slow rate sur SPI

    /**
    INLVLx registers
    */
    INLVLA = 0xFF;
    INLVLB = 0xFF;
    INLVLC = 0xFF;
    INLVLE = 0x08;
    
    RA3PPS=0;
    RB1I2C = 0x00;
    RB2I2C = 0x00;
 // RC3I2C = 0x00;
 // RC4I2C = 0x00;
    RB0PPS=0;
    RB1PPS=0;
    RB2PPS=0;
    RB3PPS=0;
    
    RC3PPS = 0x00;
    RC4PPS = 0x00;
  
    RC6PPS = 0x13;   //RC6->UART1:TX1;    
    U1RXPPS = 0x17;   //RC7->UART1:RX1;  
    U1CTSPPS = 0x00;
    RC5PPS=0;  // RC5
   
  
#ifdef With_I2C1
    //    ODCONCbits.ODCC3=1;
    //   ODCONCbits.ODCC4=1; // open collecteur sur RC4
    //  SCL_Dir=0; //  TRISCbits.TRISC3
    //  SData_Dir=0; // TRISCbits.TRISC4
    //    RC3PPS = 0x21;   //RC3->I2C1:SCL1;    
    //    RC4PPS = 0x22;   //RC4->I2C1:SDA1;  
#endif
  
   
  #ifdef With_SPI_Hardware   
 // TABLE 17-2: PPS OUTPUT REGISTER DETAILS  p282
    RC3PPS = 0x1E; //0b01 1110 SPI1 (SCK)
    RC5PPS = 0x1F; //RC5->SPI1:SDO1; 
    SPI1SDIPPS = 0x14;   //RC4->SPI1:SDI1;   
    SPI1SCKPPS = 0x13;   //RC3->SPI1:SCK1;  
    //RC2PPS = 0x20; //RC2->SS1

 #endif 
    
    _RST=1;
    _CS=1;
    _DC=0;
    PIE2bits.SPI1IE=0;
    PIE2bits.SPI1RXIE=0;
    PIE2bits.SPI1TXIE=0;
  }



void Put_Pixel(int x1,int y1,uint16_t  color)
{
    Byte ch,cl;
  ch=color>>8;
  cl=color &0x00FF;
  //_CS=0;
   if(  (x1 >= _maxX-1) || (y1 >= _maxY-1)) return;
  // set adress pixel window
  SendCmd(0x2A);
  SendData(x1>>8);SendData(x1 & 0x00FF);
  SendData(x1>>8);SendData(x1 & 0x00FF);
 SendCmd(0x2B);
  SendData(y1>>8);SendData(y1 & 0x00FF);
  SendData(y1>>8);SendData(y1 & 0x00FF);
  SendCmd(0x2C);
  SendData(ch);
  SendData(cl);
  
 }  


void Put_Big_Pixel(int x1,int y1, uint16_t color)
{   int i,j;
   if(  (x1 >= _maxX-2) || (y1 >= (_maxY-2))||(x1 <2) || (y1 <2 )) return;
   SetWindow(x1-2,y1-2,x1+2, y1+2);
  for (i=0;i<8;i++)
  {
  SendData(color>>8);
  SendData(color & 0x00FF);
  }
}



// * Draws a line on OLED by using the specified parameters.
// * <a href="https://en.wikipedia.org/wiki/Bresenham%27s_line_algorithm">
void Draw_Line( int x_start, int y_start, int x_end, int y_end, int color)
{
  int x, y, addx, addy, dx, dy;
  long P;
  int i;
  dx = abs((int)(x_end - x_start));
  dy = abs((int)(y_end - y_start));
  x = x_start;
  y = y_start;

  if(x_start > x_end)
    addx = -1;
  else
    addx = 1;

  if(y_start > y_end)
    addy = -1;
  else
    addy = 1;

  if(dx >= dy)
  {
    P = 2*dy - dx;

    for(i=0; i<=dx; ++i)
    {
      Put_Pixel (x,y,color);
      if(P < 0)
      {
        P += 2*dy;
        x += addx;
      }
      else
      {
        P += 2*dy - 2*dx;
        x += addx;
        y += addy;
      }
    }
  }
  else
  {
    P = 2*dx - dy;
    for(i=0; i<=dy; ++i)
    {
      Put_Pixel (x,y,color);

      if(P < 0)
      {
        P += 2*dx;
        y += addy;
      }
      else
      {
        P += 2*dx - 2*dy;
        x += addx;
        y += addy;
      }
    }
  }
}

void SetTextColor(int c1,int b1)
{
textColor   = c1;  // front
textBgcolor = b1;  // back
}


void SetOrientation(Byte m)
 {
    Byte rotat,x;
   // _CS=0;
   rotat = m & 0x03; // can't be higher than 3
    switch (rotat) 
    {
        case 0:
            x = MADCTL_MX | MADCTL_BGR;
            _width  = GC9A01A_TFTWIDTH;
            _height = GC9A01A_TFTHEIGHT;
            break;
        case 1:
            x = MADCTL_MV | MADCTL_BGR;
            _width  = GC9A01A_TFTHEIGHT;
            _height = GC9A01A_TFTWIDTH;
            break;
        case 2:
            x = MADCTL_MY | MADCTL_BGR;
            _width  = GC9A01A_TFTWIDTH;
            _height = GC9A01A_TFTHEIGHT;
            break;
        case 3:
            x = (MADCTL_MX | MADCTL_MY | MADCTL_MV | MADCTL_BGR);
            _width  = GC9A01A_TFTHEIGHT;
            _height = GC9A01A_TFTWIDTH;
            break;
        
    }
    SendCmd(GC9A01A_MADCTL);
    SendData(x );
    __delay_ms(100);
    SetWindow(0,0,_width,_height);   //06-03-2018
}

void Set_Color(Word Couleur)
{
 //_CS=0;
  SendCmd(0x2C);
  SendData(Couleur >>8);
  SendData(Couleur & 0x00FF);
 // _CS=1;
}

Byte GetOrientation()
 {
    return Orientation;
}


void Draw_CText(uint16_t x,uint16_t y,const unsigned char *T,uint16_t Co)
{ char * pt_RAM;
  TEXTE[0]=0;
  pt_RAM =&TEXTE[0];
  strConstRamCpy(pt_RAM,T);
  DrawText(x,y,pt_RAM,Co);
}

void DrawText(uint16_t x, uint16_t y, unsigned char * s, uint16_t color)
 {
    int currx;
    int m;
    unsigned int k,l;
    currx = x;
    l=strlen(s);
    if (l>= cfont.MaxC)  l= cfont.MaxC;
    // Print every character in string
    for (k = 0; k < l; k++) 
    {
       m= DrawChar(currx, y, *(s+k), color);
     //  currx=currx  + m + 1;
       currx=currx  + m; // + 1;
    }
    
}


unsigned char DrawChar(int x, int y, Byte ch, Word color)
 {
      int  h, i, j,k;
      Word charData=0;
    Word  charWidth=0;
  
    unsigned char cx=0;
    Word charOffset=0;
  // _CS=0;
    charOffset= (cfont.width * cfont.nbrows )+ 1;  // bytes used by each character
    charOffset =(charOffset * (ch - cfont.offset)) + FONT_HEADER_SIZE;  // char offset (add 6 for font header)
   charWidth = *(cfont.font+charOffset);
   charOffset++;  // increment pointer to first character data byte
   for (i = 0; i <= charWidth; i++) // each font "column" (+1 blank column for spacing)
    {
      h = 0;  // keep track of char height
       for (j = 0; j < cfont.nbrows; j++)
       {  // each column byte
          //  if (i >= charWidth)       // was     if (i == charWidth)   04-04-2018
          //   charData = 0x00; // Insert blank column
          //  else
            charData = *(cfont.font + charOffset);
            charOffset++;
            cx= charData;
          //   _CS=0;
            // Process every row in font character
            for (k = 0; k < 8; k++)
            {
                if (h >= cfont.height ) break;
                if ((cx & 0x0001)==1)
                 {
                 Put_Pixel(x + i, y + (j * 8) + k, color);
                 }
                else
                {
                  Put_Pixel(x + i, y + (j * 8) + k, bgColor);
                }
                h++;
                cx=cx>>1;
                __delay_us(5);
             }
           //  _CS=1;
        }
     }
    //_CS=1;
    return charWidth;
  }

void Invert_Display(char bb)
{
  _CS=0;
  if(bb>0) SendCmd(GC9A01A_INVON);
   else
    SendCmd(GC9A01A_INVOFF);
}

void DrawBitMap(int x, int y, const char *bitmap, int w, int h,uint16_t color)
{

  int i, j , byteWidth ;
  byteWidth = (w + 7) / 8;
  for(j=0; j<h; j++)
  {
    for(i=0; i<w; i++ ) 
     {
      if( (*(bitmap + j * byteWidth + i / 8)) & (128 >> (i & 7)))
       {
        Put_Pixel(x+i, y+j, color);
      }
    }
  }
}


// rappel:
// 1 Taille Font TerminaL6x8         =  677  cfont.MaxC=  25
// 2 aille TerminaL12x16             = 2405  cfont.MaxC=  14
// 3Taille Font Trebuchet_MS13x21   = 1045  cfont.MaxC=  13
// 4 Taille Font Terminal5x11        = 1061  cfont.MaxC=  32
//----------------------------
// 5 Taille Font Trebuchet_MS16x23   = 1279  cfont.MaxC=  11
// 6 Taille Font Arial_Narrow22x32   = 2319  cfont.MaxC=  8
// 7 taille Font NI7SEG22x28         = 2319  cfot.MaxC =  8
// 8 Taille Font NI7SEG26x35         = 1708  cfont.MaxC = 6


void SetFont( unsigned char * font)
 {
    cfont.font       = font;
    cfont.width    = *(font);
    cfont.height   = *(font+1);
    cfont.offset   = *(font+2);
    cfont.numchars = *(font+3);
    cfont.MaxC     = *(font+4);
    cfont.nbrows   = cfont.height >>3 ; // / 8;
   if (cfont.height % 8) cfont.nbrows++;  // Set number of bytes used by height of font in multiples of 8
    cfont.Taille=  *(font+5)<<8 | *(font+6);
    cfont.dummy= *(font+7);
}



void  Param_Font()
{
   CPrint("\r\nFont Active #");
   PrintChar(Font_Active+48);CPrint(" : ");
   CPrint(FontNames[Font_Active-1]);CRLF1();
   
   sprintf(CRam1," cfont.width= %3d ",cfont.width ) ;
   Print(CRam1);
   sprintf(CRam1," , cfont.height= %3d", cfont.height)  ;
   Print(CRam1);
   sprintf(CRam1," cfont.nbrows= %3d \r\n",cfont.nbrows )  ;
   Print(CRam1);
   sprintf(CRam1," cfont.MaxC= %3d cars maxi par ligne \r\n",cfont.MaxC )  ;
   Print(CRam1);
   sprintf(CRam1," cfont.Taille= %5d \r\n ",cfont.Taille)  ;
   Print(CRam1);
 //   sprintf(CRam1," , cfont.dummy= %3d  \r\n",cfont.dummy)  ;
 //  Print(CRam1);
  
}
void Select_Font_Type(int Type)
 {
    int i, T1;
    if(Bavard==1) CPrint("\r\n Taille Font ");
    switch(Type)
    {
     case 1:
      {
      T1=sizeof(TerminaL6x8) ;
      sprintf(CRam1," TerminaL6x8 = %5d \r\n",T1);
      Print(CRam1);
      SetFont(&TerminaL6x8[0]);   // taille 672
      T1=cfont.Taille;   
      pp=  malloc(T1);
      if (pp==0)
       {
         CPrint(" Mesg_Alerte 1\r\n");  break;
       }
      else
      {    
      // chargement de la fonte
       for (i=0;i<T1;i++)  *(pp+i)=TerminaL6x8[i];
       SetFont(pp);
      }
       break;
      }
      case 2:
     {
     
      T1=sizeof(TerminaL12x16) ;
      sprintf(CRam1," TerminaL12x16 = %5d \r\n",T1);
      Print(CRam1);
       SetFont(&TerminaL12x16[0]); 
      T1=cfont.Taille;
    //   if(Bavard==1)
    //   {
    //     sprintf(CRam1," TerminaL12x16 = %5u \r\n",T1);
    //     Print(CRam1); 
    //   }
       pp=(char *) malloc(T1);
       if (pp==0)
       {
         CPrint(" Mesg_Alerte 2\r\n");  break;
       }
       for (i=0;i<T1;i++)  *(pp+i)=TerminaL12x16[i];
       SetFont(pp);
       break ;
     }
     case 3:
     {
      
      T1=sizeof(Trebuchet_MS16x23) ;
      sprintf(CRam1," Trebuchet_MS16x23 = %5d \r\n",T1);
      Print(CRam1);
      SetFont(&Trebuchet_MS16x23[0]); 
      T1=cfont.Taille;
     //  if(Bavard==1)
     //  {
     //   sprintf(CRam1," Trebuchet_MS16x23=  %5u \r\n",T1);
     //   Print(CRam1); 
     //  }
       pp=(char *) malloc(T1);
       if (pp==0)
       {
         CPrint("Mesg_Alerte 3\r\n");   break;
       }
       for (i=0;i<T1;i++) *(pp+i)=Trebuchet_MS16x23[i];
       SetFont(pp);
       break;
      }
      case 4:
     {
 
      T1=sizeof(Arial_Narrow22x32) ;
      sprintf(CRam1," Arial_Narrow22x32 = %5d \r\n",T1);
      Print(CRam1);
       SetFont(&Arial_Narrow22x32[0]); 
       T1=cfont.Taille;;
    //   if(Bavard==1)
    //   {
    //    sprintf(CRam1," Arial_Narrow22x32=  %5u \r\n",T1);
    //    Print(CRam1); 
     //  }
      pp=(char *) malloc(T1);
       if (pp==0)
       {
         CPrint("Mesg_Alerte 4\r\n");   break;
       }
       for (i=0;i<T1;i++) *(pp+i)=Arial_Narrow22x32[i];
       SetFont(pp);
       break;
      }
       case 5:
     {
      T1=sizeof(NI7SEG22x28) ;
      sprintf(CRam1," NI7SEG22x28 = %5d \r\n",T1);
      Print(CRam1);
       SetFont(&NI7SEG22x28[0]); 
       
       T1=cfont.Taille;;
     //  if(Bavard==1)
     //  {
     //   sprintf(CRam1," NI7SEG22x28 =  %5u \r\n",T1);
    //    Print(CRam1); 
     //  }
      pp=(char *) malloc(T1);
       if (pp==0)
       {
         CPrint("Mesg_Alerte 5\r\n");   break;
       }
       for (i=0;i<T1;i++) *(pp+i)=NI7SEG22x28[i];
       SetFont(pp);
       break;
      }
     case 6:
     {
      
      T1=sizeof(NI7SEG26x35) ;
      sprintf(CRam1," NI7SEG26x35 = %5d\r\n",T1);
      Print(CRam1);
       SetFont(&NI7SEG26x35[0]); 
       T1=cfont.Taille;
       pp=(char *) malloc(T1);
       if (pp==0)
       {
         CPrint("Mesg_Alerte 6\r\n");   break;
       }
       for (i=0;i<T1;i++) *(pp+i)=NI7SEG26x35[i];
       SetFont(pp);
       break;
      }  
       defautlt :
      {
       CPrint("..Erreur .. 6 fontes seulement!!\r\n");
       __delay_ms(1000);
       break;
     }
   } // switch
    if((Bavard==1) && (Type>0) && (Type<7))  
     {
       Param_Font();
     }
 }


void Close_Font_Type(int Type)
{
   if(Bavard==1)
   {
       CPrint(" Close Font ");
       CPrint(FontNames[Type-1]);
       CRLF1();
   }
    free(pp);
}
   
  /* 
   switch(Type)
   {
    case 1:
      {
        if(Bavard==1) CPrint("TerminaL6x8\r\n" );
        free(pp);
        break;
      }
      case 2:
      {
        if(Bavard==1) CPrint("TerminaL12x16\r\n");
        free(pp);
        break ;
      }
      case 3:
      {
      if(Bavard==1) CPrint("Trebuchet_MS16x23\r\n");
        free((char *)pp);
        break;
      } 
      case 4:
      {
        if(Bavard==1) CPrint(" Arial_Narrow22x32\r\n");
        free((char *)pp);
        break;
      }
      case 5:
      {
        if(Bavard==1) CPrint(" NI7SEG22x28 \r\n");
        free((char *)pp);
        break;
      }
      case 6:
      {
        if(Bavard==1) CPrint(" NI7SEG26x35 \r\n");
        free((char *)pp);
        break;
      }
      defautlt:
      CPrint("Erreur close font \r\n");
      __delay_xSec(2);
      break;
    }
  }
   */


void Ecran_Noir(void)
{ Word i;
  SendCmd(0x2A);
  SendData(0);SendData(0); SendData(0);SendData(0xEF);
  SendCmd(0x2B);
  SendData(0);SendData(0); SendData(0);SendData(0xEF);
  SendCmd(0x2C);
  i=0;
  do
  {
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  SendData(0x00);SendData(0x00);
  i++;
  }while(i<5760);
  SendCmd(0x2A);
  SendData(0);SendData(0); SendData(0);SendData(0xEF);
  SendCmd(0x2B);
  SendData(0);SendData(0); SendData(0);SendData(0xEF);
  SendCmd(0x2C);
 
}


void SetWindow(uint16_t x1, uint16_t  y1, uint16_t  x2, uint16_t  y2)
{  
  SendCmd(0x2A);                    // set column address
  SendData(x1 >>8); SendData(x1 & 0x00ff);
  SendData(x2 >>8); SendData(x2 & 0x00ff);
  SendCmd(0x2B);                    // set page address (=row)
  SendData(y1 >>8); SendData(y1 & 0x00ff);
  SendData(y2 >>8); SendData(y2 & 0x00ff);
  SendCmd(0x2C);  // ecrit en RAM
}

/*    
    Byte a,b;
  SendCmd(0x2A);                    // set column address
  a=(x1>>8); b=(x1&0x00ff);  SendData(a);SendData(b);
  a=(x2>>8); b=(x2&0x00ff); SendData(a);SendData(b);
  SendCmd(0x2B);   // set page address (=row)
  a=(y1>>8); b=(y1&0x00ff);  SendData(a);SendData(b);
  a=(y2>>8); b=(y2&0x00ff); SendData(a);SendData(b);
  SendCmd(0x2C);  // ecrit en RAM
}
 * */


void Rectangle_Plein(int x1,int y1, int x2,int y2,Word color)
{ int i,j,dx,dy;
  SendCmd(0x2A);
  SendData(x1>>8);SendData(x1 &0x00FF);
  SendData(x2>>8);SendData(x2 &0x00FF);
  SendCmd(0x2B);
  SendData(y1>>8);SendData(y1 &0x00FF);
  SendData(y2>>8);SendData(y2 &0x00FF);
 // SendCmd(0x2C);
  dx=abs(x2-x1)+1;
  dy=abs(y2-y1)+1;
  SendCmd(0x2C);
  for (i=0;i<dx;i++)
  {
   for (j=0;j<dy;j++) 
   {
   SendData(color>>8);
   SendData(color & 0x00FF);
   }
  }
}

void Clear_LCD(void)
{
 Word i1;    // taille Word suffisante avec ecan 240x240  mais usage d'un  Long si ecran 320x240 !!
 SendCmd(0x2A);                    // set column address
  SendData(0); SendData(0);
  SendData(0); SendData(239);
  SendCmd(0x2B);                    // set page address (=row)
  SendData(0); SendData(0);
  SendData(0); SendData(239);
  SendCmd(0x2C);  // ecrit en RAM
  for (i1=0;i1<57600;i1++)
  {
    SendData(0);
    SendData(0);
  }
}


void My_Init_SPI1(void)
{ //rev 20-03-2023
  // 3D14h SPI1CON0 : EN ? ? ? ? LSBF MST BMODE  .page 540   
  SPI1CON0 = 0x00;
  SPI1CON0bits.EN = 0;// on  
  SPI1CON0bits.MST=1;  // SPI module operates as the bus host  
  SPI1CON0bits.BMODE=1;  
  // SPI1CON0 = 0x03;    // off, msb first, master, BMODE=1
  // 3D15h SPI1CON1:  SMP CKE CKP FST ? SSP SDIP SDOP . page 541
  SPI1CON1 = 0x00;   
  SPI1CON1bits.SMP =0;// reserved ???
  SPI1CON1bits.CKE=1; // 1= Data change sur front descendant ,0 = changes sur Front Montant
  SPI1CON1bits.CKP=0; // Clock Polarity 0 = Idle state for SCK is low level
  SPI1CON1bits.FST=1;// Fast Start Enable bit  1 = Delay to first SCK may be <  baud period  0 = Delay to first SCK >  baud period
  //En mode 0 et 3, le pic crit le bit au front descendant, le slave lit au front montant.
  //En mode 1 et 2, le pic crit le bit au front montant, le slave lit au front descendant.
  //mode 0 (CKP=0, CKE=1)<-- OK
  //mode 1 (CKP=CKE=0) 
  //mode 2 (CKP=CKE=1).       
  //mode 3 (CKP=1, CKE=0)
   //mode0  ok
  //SPICON2  : BUSY(1) SSFLT ? ? ? SSET TXR(2) RXR  page 541
  SPI1CON2=0x00;
  //19/03
  // SPI1CON2 = 0x03;    // SSET=0, TXR=1, RXR=1
  // SPI1CON2bits.BUSY  en lecture seule
  SPI1CON2bits.SSET=1;// host mode :  0 = SS(out) is driven to the active state while the transmit counter is not zero
                     // host mode  :  1 = SS(out) is driven to the active state continuously
  SPI1CON2bits.TXR=1; //1 = TxFIFO data is required for a transfer
  SPI1CON2bits.RXR=1; // 0=Received data is not stored in the FIFO  1=1 = Data transfers are suspended if the RxFIFO is full
  // The BUSY bit is subject to synchronization delay of up to two instruction cycles.
  // CLKREF :  2->MFINTOSC=500Khz , 1->HFINTOSC=16Mhz  ,0->FOSC=64MHz
  // SPI1CLK  = 1;     //CLKREF =1   
  // SPI1BAUD = 3;     // SPI Speed 16MHz / (2x(3+1)) = 16/8 = 2MHz .. OK
  //  SPI1CLK  = 1;    
  //  SPI1BAUD = 1;     // SPI Speed 16MHz / (2x(1+1)) = 16/4 = 4MHz 
 //  SPI1CLK  = 0;       // CLKREF =0  ->FOSC=64MHz
 //  SPI1BAUD = 1;       // SPI Speed 64MHz / (2x(3+1)) = 64/8 = 8MHz ..OK!!
  SPI1CLK  = 0;       // CLKREF =0  ->FOSC=64MHz
  SPI1BAUD = 3;       // SPI Speed 64MHz / (2x(0+1)) = 64/2 = 32MHz
  SLRCONC=0; 
  SLRCONB=0; 
  LATCbits.LATC2 = 1; // SS high
  SPI1CON0bits.EN = 1;// on
}


// voir https://fantaspic.fr/viewtopic.php?f=10&t=1292&start=20
//OLED GC9A01 et SPI Hardw 18F27K42
void SendData(uint8_t cc) // SS low par LATCbits.LATC2=0  prealablement !
{
  uint8_t dummy;
  _DC = 1;
  SPI1TXB = cc;
  __asm("NOP");
   while (!PIR2bits.SPI1RXIF) { };
 dummy = SPI1RXB;
}

void SendCmd(uint8_t cc) //SS low par LATC2=0  prealablement !
{  uint8_t dummy;;
  _DC = 0;
  SPI1TXB = cc;
   __asm("NOP");
   while (!PIR2bits.SPI1RXIF) { };
   dummy = SPI1RXB;
}


Byte  SPI1_WriteByte(uint8_t bb) 
{  Byte rep;
    SPI1TCNTH=0;
    SPI1TCNTL=1;   
    SPI1TXB = bb;
    while (!PIR2bits.SPI1RXIF)// Check for any SPI Receive Interrupts;
   {
    }; 
   rep=SPI1RXB;
  return (rep); // Return data from SPI Receive Buffer Register;
}



  
void Start_SMT1()
{  
     SMT1_Measure=0;
     ST=& SMT1_Measure;
   //PIR1 SMT1PWAIF SMT1PRAIF SMT1IF C1IF ADTIF ADIF ZCDIF INT0IF 138 
    PIR1bits.SMT1IF=0;
    SMT1CON0bits.SMT1STP=0;
    SMT1STATbits.RST=1;   // init FFFFFF
    SMT1CON1bits.SMT1GO=1;
}
    
void Stop_SMT1()
{
    SMT1CON1bits.SMT1GO=0;
   // SMT1_Measure=SMT1TMR;
   *(ST)=  SMT1TMRL;
   *(ST+1)=SMT1TMRH;
   *(ST+2)=SMT1TMRU;
   *(ST+3)=0;
    
    if (PIR1bits.SMT1IF==1) 
    {
         CPrint("  Over !\r\n");
         SMT1_Measure=SMT1_Measure+0x1000000;
    }   
    PIR1bits.SMT1IF=0 ; 
    sprintf(txt, " Stop. SMT1=%lu ,soit ",SMT1_Measure);
    Print(txt);
    // pour fosc 500Khz
    L1= SMT1_Measure <<1 ; // *2
    //pour FOSC=64MHz
    //L1= SMT1_Measure >>6 ; //64
     //pour FOSC=16MHz
   // L1= SMT1_Measure >>4 ; //16
    sprintf(txt, "%lu uS\r\n",L1); 
    Print(txt);
    CRLF1();  
 }


void Attente_s_Clavier(void)
{ char c;
  char b;
   c=0;
 
  PIE3bits.U1RXIE =0;
   CPrint(" attente appui sur s \r\n");
   TMR6_Init_500ms(6); // 6x500mS ->3sec
 // while ( c1!='s')
 //  while ( Flag_Buffer1==0) 
  while  (PIR3bits.U1RXIF==0) 
  { 
      if ( Buffer1[0]=='s') break;
     
      if(Drapeaux.Tmr6_Elapsed==1) break;
  };
   c= U1RXB ;
  Drapeaux.Tmr6_Elapsed = 0 ;
}

void main(void)
{
    // FOSC INTERNE
    OSCCON1 = 0x60;
    OSCCON3 = 0x00;
    OSCEN = 0x00;
    OSCFRQ = 0x08;  // 64Mhz
    OSCTUNE = 0x00;
    __delay_ms(100);
    
   Init_Hardware() ;  // sauf SPI !
   UART1_Init(); 
   
   for (i=0;i<4;i++)
   {
        Led_R=1;
        //__asm("btg LATA,4");  //Led_R
        __delay_ms(200);
         Led_R=0;
        __delay_ms(200);
   }    
    
    k= sizeof(Buffer1)-1;
    for (i=0;i<k;i++) Buffer1[i]=0;
    for (i=0;i<sizeof(CRam1)-1;i++) CRam1[i]=0;
    for (i=0;i<sizeof(TEXTE)-1;i++) TEXTE[i]=0; 
    txt= &TEXTE[0];
    *(txt)=0; 
    CRLF1(); 
    Cpt6=0;
    
    CRLF1();
    CPrint(" Test SPI Hardware 18F27K42\r\n");
    CPrint(" Projet MPLABX :C:\\MPLABX_Projects\\_18F27k42_OLED_SPI_Hw_CG9A01_2023-11.X\r\n");
    CPrint(" Version : "VERSION"\r\n"); 
     k=sprintf(txt," Compile le %s a %s UTC\r\n avec version XC8 :  %d et "PACK" \r\n", __DATE__, __TIME__,__XC8_VERSION);
    Print(txt);
    CPrint(" Hardware : PIC18F27K42  FOSC interne 64Mz\r\n");
    CPrint(" SOURCES : \r\n"Source"\r\n");
    CPrint(" AUTRES : \r\n"Others"\r\n");
    CPrint(" UART1  RC6=TX  115200,8,N,1 \r\n");
    CPrint(" SPI HARDWARE at 32 MHz:\r\n");
    CPrint(" RC3=SCLK  RC5=SDA  RC2=SS  , cdes sur PORTB:  RB1=_CS    RB2=_RST,  RB3=_DC (ou A0)\r\n");
    CPrint(" Usage de malloc (Heap) pour utiliser les fontes \r\n");
    CRLF1(); 
    
 
   SQA=0;
     Led_R=1;
 
     CPrint("\r\n Init Compteur 24 bits SMT1, avec choix clock 4=> 500KHz  tick=2uS\r\n");
     //  0=FOSC/4  1=FOSC  2=HINTOSC 16MHz   4= MFINTOSC (500 kHz ) 5=MFINTOSC/16 (31.25kHz) 
    SMT1_Init(4);  // 500Khz
     
    START_SMT1
  //  __delay_ms(100);
    __delay_xSec(2);
    STOP_SMT1
    
    L1=SMT1_Measure; 
    L2=L1<<1;    //  500Khz tick=2S => multiplie par 2   ,  31,25KHz L1>>5 par 32
    sprintf(txt," Test SMT1 avec __delay_xSec(2) , Nb Tics %lu L2=%lu uS\r\n",L1,L2);
    Print(txt);
    
   
   
    CPrint(" My_Init SPI1\r\n");
    My_Init_SPI1();
    SMT1CON0bits.SMT1EN =1;
     
    CRLF1();
    _width  =GC9A01A_TFTWIDTH;
   _maxX = _width -1;
   _height=GC9A01A_TFTHEIGHT;
   _maxY =_height-1;


    CRLF1();  
    CPrint(" test  SMT1 pour  __delay_xSec(2); \r\n");
   // RC2 =1; //SS low 
    Start_SMT1();
   __delay_xSec(2);
    Stop_SMT1();
   _CS=0;
    Print(" fin d'init LCD\r\n");
   
    CRLF1();
    CPrint(" Clear_LCD() \r\n");
    Clear_LCD();
    CRLF1();
     CPrint(" Test duree Ecran Noir (SPI 32MHz!) \r\n"); 
     Start_SMT1();
     Ecran_Noir();
     Stop_SMT1();
     CRLF1();
    
     
//   do
//   {
      CRLF1(); 
     
      

   //  Orientation++;
   //  if (Orientation>3) Orientation=0;
   //  SetOrientation(Orientation);
     CPrint(" -----  SetOrientation =");
     PrintChar(Orientation+48);
      CPrint(" ----- \r\n");   
       
       
       
   Ecran_Noir();  
    __asm("btg LATA,4");
   CPrint(" put 8 big pixels \r\n"); 
   Put_Big_Pixel(40,40,_Blanc);
   Put_Big_Pixel(40,200,_Tomate);
   Put_Big_Pixel(160,120,_Rouge);
   Put_Big_Pixel(60,120,_Jaune); 
   Put_Big_Pixel(180,80,_Magenta);
   Put_Big_Pixel(180,160,_Jaune); 
   Put_Big_Pixel(40,200,_Tomate);
   Put_Big_Pixel(100,160,_Azur);
   Put_Big_Pixel(120,140,_Orange);
    __asm("btg LATA,4");
    __delay_xSec(1);
    
 //  CPrint(" Ecran Noir \r\n"); 
 //  Ecran_Noir();  
   

 //   Ecran_Noir(); 
 //  CPrint(" Drapeau\r\n");
 //  CPrint(" Rectangle_Plein x1=60 y1=60  x2=80  y2=120 Bleu \r\n");
 //  Rectangle_Plein(60,30,80,120,COLOR_BLUE);
 //  CPrint(" Rectangle_Plein x1=80 y1=60 x2=100 y2=120 Blanc\r\n");
 //  Rectangle_Plein(80,30,100,120,COLOR_WHITE );
 //  CPrint(" Rectangle_Plein x1=120 y1=120 x2=130 y2=130 Rouge\r\n");
//   Rectangle_Plein(100,30,120,120,_Rouge );
 //       __delay_xSec(1);
   
    Ecran_Noir(); 
    CPrint("\r\n  Affichage Daffy_Duck_BMP 120x120\r\n");
    DrawBitMap(60,60,duck_120_bitmap,120,120,_GREY) ;
    CPrint(" ..fin Affichage Image Daffy \r\n");
    CRLF1();
    __delay_xSec(1); 
    Invert_Display(0);
    __delay_xSec(1);        
    Invert_Display(1);   

    Interrupt_Init();
    INTCON0bits.GIE = 1;
       
   //REGISTER 21-3: TxCLK: TIMERx CLOCK REGISTER
    T6CLK=5;    // 1=FOSC/4   2 =>FOSC   5=MFINTOSC500Khz

    CPrint(" Init Timer6 8*500mS -> 4sec \r\n");
    Drapeaux.Tmr6_Elapsed=0;
    Start_SMT1();
    TMR6_Init_500ms(8)  ;
    while(Drapeaux.Tmr6_Elapsed==0)
    {
    };
     Stop_SMT1();
    L1=SMT1_Measure; 
    L2=L1<<1;    //  500Khz tick=2S => multiplie par 2   ,  31,25KHz L1>>5 par 32
    sprintf(txt," Chrono SMT1 avec TMR6_Init_500ms(4) , Nb Tics %lu L2=%lu mS\r\n",L1,L2/1000);
    Print(txt);
        
   do
   {
    
    Clear_LCD();
    CRLF1();
   CPrint(" Texte sur LCD ..\r\n");
    
    //===== mode texte ==========
    /*
    CRLF1();
    CPrint(" Texte sur LCD ..\r\n"); 
   Bavard=1;
   Font_Active=1;
   CPrint(" Efface ecran (Noir)\r\n");
   Ecran_Noir();  //Rectangle_Plein(0,0,239,239,0);
   CPrint(" Fonte active #1\r\n");
   Select_Font_Type(Font_Active);
   CPrint(" Ecritures sur LCD\r\n");
   strConstRamCpy(Buffer_Font,"ABCDEFGHIJKLM");
   DrawText(40, 12, Buffer_Font,_CYAN);
   CPrint(" Presentation YELLOW\r\n");
   Draw_CText(20, 22, "Presentation",COLOR_YELLOW);
   CPrint(" LCD GC9A101 240x240 65K c WHITE\r\n");
   Draw_CText(20, 32, "LCD GC9A01 240x240 65K c",COLOR_WHITE);
   Draw_CText(30, 42, "MCU : " MCU,_RED) ;
   Draw_CText(30, 52, "Power supply: "POWER_SUPPLY,_BLUE) ;
   Draw_CText(30, 62,Directory,_WHITE) ;
   Draw_CText(30, 72,Project,_CYAN);
   Draw_CText(30, 82, "MPLABX XC8",_GREEN);
   Draw_CText(20, 92,Source,COLOR_YELLOW);
   Draw_CText(20, 102,"Version : "VERSION,COLOR_OLIVE);
   Draw_CText(20, 112," FOSC interne : " FOSC,COLOR_RED) ;
   strConstRamCpy(Buffer_Font,"ABCDEFGHIJKLMNOPQRSTUVWXYZ");
   //PrintChar(32);
   Print(Buffer_Font); CRLF1();
   DrawText(20, 122 ,Buffer_Font,_YELLOW);
   Draw_CText(40, 142,"paulfjujo.free.fr",_MAGENTA);
   //Close_Font_Type(Font_Active);
   __delay_xSec(3);
    Close_Font_Type( Font_Active);
    */
     
    
   Bavard=1;
 
   CPrint(" Efface ecran (Noir)\r\n");
   Font_Active=1;
   CPrint(" Efface ecran (Noir)\r\n");
   Ecran_Noir();  //Rectangle_Plein(0,0,239,239,0);
   Select_Font_Type(Font_Active);
   Draw_CText(2, 100, "1234567890123456789012345678901234567890",_WHITE);
   Close_Font_Type( Font_Active);
    __delay_xSec(1);
    
   Attente_s_Clavier(); // appuyer sur s
    
   Font_Active=2;
   CPrint(" Efface ecran (Noir)\r\n");
   Ecran_Noir();  //Rectangle_Plein(0,0,239,239,0);
   Select_Font_Type(Font_Active);
   Draw_CText(2, 100, "123456789012345678",_GREEN);
    Close_Font_Type( Font_Active);
   Attente_s_Clavier(); // appuyer sur s
  
   Font_Active=3;
   CPrint(" Efface ecran (Noir)\r\n");
   Ecran_Noir();  //Rectangle_Plein(0,0,239,239,0);
   Select_Font_Type(Font_Active);
   Draw_CText(2, 100, "1234567890123456789012",_YELLOW);
   Close_Font_Type( Font_Active);
   __delay_xSec(1);
       
   Attente_s_Clavier(); // appuyer sur s
    
   Font_Active=4;
   CPrint(" Efface ecran (Noir)\r\n");
   Ecran_Noir();  //Rectangle_Plein(0,0,239,239,0);
   Select_Font_Type(Font_Active);
   Draw_CText(2, 100, "1234567890123456",_WHITE);
   Close_Font_Type( Font_Active);
    __delay_xSec(1);
    Attente_s_Clavier(); // appuyer sur s
    
   Font_Active=5;
   CPrint(" Efface ecran (Noir)\r\n");
   Ecran_Noir();  //Rectangle_Plein(0,0,239,239,0);
   Select_Font_Type(Font_Active);
   Draw_CText(2, 100, "1234567890123456",_GREEN);
   Close_Font_Type( Font_Active);
   Attente_s_Clavier(); // appuyer sur s 
    
   Font_Active=6;
   CPrint(" Efface ecran (Noir)\r\n");
   Ecran_Noir();  //Rectangle_Plein(0,0,239,239,0);
   Select_Font_Type(Font_Active);
   Draw_CText(2, 100, "1234567890",_YELLOW);
   Close_Font_Type( Font_Active);
   Attente_s_Clavier(); // appuyer sur s

          
  //  __delay_xSec(1);
     
      SetWindow(0,0,239,239); 
      Ecran_Noir();
   
       RAZ_UART1_Buffer1();
      __delay_xSec(2);
      if (Flag_Buffer1==1)
      {
          CPrint(" Recu : ");
          Print(Buffer1);
          CRLF1();
      }   
    
    
    
    

 
    __asm("btg LATA,4");
     
   
   }
  while(1);
  
}


/*
 
 (18:14:56.595)  Test SPI Hardware 18F27K42
(18:14:56.628)  Projet MPLABX :C:\MPLABX_Projects\18F27k42_ RFID_reader_2023.X
(18:14:56.628)  Version : 2023-1116
(18:14:56.628)  Compile le Nov 16 2023 a 18:13:23 UTC
(18:14:56.628)  avec version XC8 :  2360 et PIC18F-K_DFP 1.6.125 
(18:14:56.628)  Hardware : PIC18F27K42  FOSC interne 64Mz
(18:14:56.628)  SOURCES : 
(18:14:56.628)  main.c, Config.c, Init_GC9A01.c
(18:14:56.628)  AUTRES : 
(18:14:56.628)  Defines_data.h, Init_GC9A01.h  TFT_6_Fonts_CG9A01.h
(18:14:56.653)  RGB_colors.h, Daffy_Duck_Bmp.h
(18:14:56.653) 
(18:14:56.653)  UART1  RC6=TX  115200,8,N,1 
(18:14:56.653)  SPI HARDWARE at 32 MHz:
(18:14:56.653)  RC3=SCLK  RC5=SDA  RC2=SS  , cdes sur PORTB:  RB0=_RST,  RB1=_CS , RB2=_DC (ou A0)
(18:14:56.653)  Usage de malloc (Heap) pour utiliser les fontes 
(18:14:56.653) 
(18:14:56.653) 
(18:14:56.653)  Init Compteur 24 bits SMT1, avec choix clock 4=> 500KHz  tick=2uS
(18:14:58.649)  Test SMT1 avec __delay_xSec(2) , Nb Tics 999999 L2=1999998 uS
(18:14:58.673)  My_Init SPI1
(18:14:58.673) 
(18:14:58.673) 
(18:14:58.673)  test  SMT1 pour  __delay_xSec(2); 
(18:15:00.652)  Stop. SMT1=1000000 ,soit 2000000 uS
(18:15:00.700) 
(18:15:00.700)  fin d'init LCD
(18:15:00.700) 
(18:15:00.700)  Clear_LCD() 
(18:15:00.958) 
(18:15:00.958)  Test duree Ecran Noir (SPI 32MHz!) 
(18:15:01.234)  Stop. SMT1=135203 ,soit 270406 uS
(18:15:01.272) 
(18:15:01.272) 
(18:15:01.272) 
(18:15:01.272)  -----  SetOrientation =0 ----- 
(18:15:01.511)  put 8 big pixels 
(18:15:02.776) 
(18:15:02.778)   Affichage Daffy_Duck_BMP 120x120
(18:15:03.656)  ..fin Affichage Image Daffy 
(18:15:03.656) 
(18:15:05.644)  Init Timer6 8*500mS -> 4sec 
(18:15:09.642)  Stop. SMT1=2007040 ,soit 4014080 uS
(18:15:09.695) 
(18:15:09.695)  Chrono SMT1 avec TMR6_Init_500ms(4) , Nb Tics 2007040 L2=4014 mS
(18:15:09.956) 
(18:15:09.956)  Texte sur LCD ..
(18:15:10.026)  Efface ecran (Noir)
(18:15:10.026)  Efface ecran (Noir)
(18:15:10.231) 
(18:15:10.231)  Taille Font  TerminaL6x8 =   680 
(18:15:10.287) 
(18:15:10.287) Font Active #1 : TerminaL6x8 40 cars     
(18:15:10.287)  cfont.width=   6  , cfont.height=   8 cfont.nbrows=   1 
(18:15:10.287)  cfont.MaxC=  40 cars maxi par ligne 
(18:15:10.287)  cfont.Taille=   680 
(18:15:10.287)   Close Font TerminaL6x8 40 cars     
(18:15:11.349)  attente appui sur s 
(18:15:14.348)  Efface ecran (Noir)
(18:15:14.616) 
(18:15:14.616)  Taille Font  TerminaL12x16 =  2408 
(18:15:14.675) 
(18:15:14.675) Font Active #2 : TerminaL12x16 18 cars   
(18:15:14.675)  cfont.width=  12  , cfont.height=  16 cfont.nbrows=   2 
(18:15:14.675)  cfont.MaxC=  18 cars maxi par ligne 
(18:15:14.675)  cfont.Taille=  2408 
(18:15:14.675)   Close Font TerminaL12x16 18 cars   
(18:15:14.827)  attente appui sur s 
(18:15:17.807)  Efface ecran (Noir)
(18:15:18.078) 
(18:15:18.078)  Taille Font  Trebuchet_MS16x23 =  1282 
(18:15:18.133) 
(18:15:18.133) Font Active #3 : Trebuchet_MS16x23 14cars
(18:15:18.133)  cfont.width=  16  , cfont.height=  23 cfont.nbrows=   3 
(18:15:18.133)  cfont.MaxC=  15 cars maxi par ligne 
(18:15:18.133)  cfont.Taille=  1282 
(18:15:18.133)   Close Font Trebuchet_MS16x23 14cars
(18:15:19.329)  attente appui sur s 
(18:15:22.324)  Efface ecran (Noir)
(18:15:22.597) 
(18:15:22.597)  Taille Font  Arial_Narrow22x32 =  2322 
(18:15:22.655) 
(18:15:22.655) Font Active #4 : Arial_Narrow22x32 12cars
(18:15:22.655)  cfont.width=  22  , cfont.height=  32 cfont.nbrows=   4 
(18:15:22.655)  cfont.MaxC=  13 cars maxi par ligne 
(18:15:22.655)  cfont.Taille=  2322 
(18:15:22.655)   Close Font Arial_Narrow22x32 12cars
(18:15:23.966)  attente appui sur s 
(18:15:26.962)  Efface ecran (Noir)
(18:15:27.232) 
(18:15:27.232)  Taille Font  NI7SEG22x28 =  2322 
(18:15:27.302) 
(18:15:27.302) Font Active #5 : NI7SEG22x28 12 cars     
(18:15:27.302)  cfont.width=  22  , cfont.height=  28 cfont.nbrows=   4 
(18:15:27.302)  cfont.MaxC=  12 cars maxi par ligne 
(18:15:27.302)  cfont.Taille=  2327 
(18:15:27.302)   Close Font NI7SEG22x28 12 cars     
(18:15:27.587)  attente appui sur s 
(18:15:30.533)  Efface ecran (Noir)
(18:15:30.803) 
(18:15:30.803)  Taille Font  NI7SEG26x35 =  1711
(18:15:30.865) 
(18:15:30.865) Font Active #6 : NI7SEG26x35  9  cars    
(18:15:30.865)  cfont.width=  26  , cfont.height=  35 cfont.nbrows=   5 
(18:15:30.865)  cfont.MaxC=   9 cars maxi par ligne 
(18:15:30.865)  cfont.Taille=  1712 
(18:15:30.865)   Close Font NI7SEG26x35  9  cars    
(18:15:31.226)  attente appui sur s 
(18:15:36.728) 
(18:15:36.728)  Texte sur LCD ..
(18:15:36.777)  Efface ecran (Noir)

 
 
CLEAN SUCCESSFUL (total time: 59ms)
make -f nbproject/Makefile-default.mk SUBPROJECTS= .build-conf
make[1]: Entering directory 'C:/MPLABX_Projects/18F27k42_ RFID_reader_2023.X'
make  -f nbproject/Makefile-default.mk dist/default/production/18F27k42__RFID_reader_2023.X.production.hex
make[2]: Entering directory 'C:/MPLABX_Projects/18F27k42_ RFID_reader_2023.X'
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=18F27K42 -c   -mdfp="C:/Users/Paul/.mchp_packs/Microchip/PIC18F-K_DFP/1.6.125/xc8"  -fno-short-double -fno-short-float -memi=wordwrite -O0 -fasmfile -maddrqual=ignore -xassembler-with-cpp -mwarn=-3 -Wa,-a -DXPRJ_default=default  -msummary=-psect,-class,+mem,-hex,-file  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-download -mdefault-config-bits   -std=c99 -gdwarf-3 -mstack=compiled:auto:auto:auto     -o build/default/production/_ext/1426725365/RC522_SPI_Hardw.X.p1 "C:/MPLABX_Projects/18F27k42_ RFID_reader_2023.X/RC522_SPI_Hardw.X.c" 
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=18F27K42 -c   -mdfp="C:/Users/Paul/.mchp_packs/Microchip/PIC18F-K_DFP/1.6.125/xc8"  -fno-short-double -fno-short-float -memi=wordwrite -O0 -fasmfile -maddrqual=ignore -xassembler-with-cpp -mwarn=-3 -Wa,-a -DXPRJ_default=default  -msummary=-psect,-class,+mem,-hex,-file  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-download -mdefault-config-bits   -std=c99 -gdwarf-3 -mstack=compiled:auto:auto:auto     -o build/default/production/_ext/1426725365/main.p1 "C:/MPLABX_Projects/18F27k42_ RFID_reader_2023.X/main.c" 
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=18F27K42 -c   -mdfp="C:/Users/Paul/.mchp_packs/Microchip/PIC18F-K_DFP/1.6.125/xc8"  -fno-short-double -fno-short-float -memi=wordwrite -O0 -fasmfile -maddrqual=ignore -xassembler-with-cpp -mwarn=-3 -Wa,-a -DXPRJ_default=default  -msummary=-psect,-class,+mem,-hex,-file  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-download -mdefault-config-bits   -std=c99 -gdwarf-3 -mstack=compiled:auto:auto:auto     -o build/default/production/_ext/1426725365/Config.p1 "C:/MPLABX_Projects/18F27k42_ RFID_reader_2023.X/Config.c" 
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=18F27K42 -c   -mdfp="C:/Users/Paul/.mchp_packs/Microchip/PIC18F-K_DFP/1.6.125/xc8"  -fno-short-double -fno-short-float -memi=wordwrite -O0 -fasmfile -maddrqual=ignore -xassembler-with-cpp -mwarn=-3 -Wa,-a -DXPRJ_default=default  -msummary=-psect,-class,+mem,-hex,-file  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-download -mdefault-config-bits   -std=c99 -gdwarf-3 -mstack=compiled:auto:auto:auto     -o build/default/production/_ext/1426725365/Init_GC9A01.p1 "C:/MPLABX_Projects/18F27k42_ RFID_reader_2023.X/Init_GC9A01.c" 
C:/MPLABX_Projects/18F27k42_ RFID_reader_2023.X/main.c:679:14: warning: implicit conversion changes signedness: 'int' to 'uint8_t' (aka 'unsigned char') [-Wsign-conversion]
  SendData(x1>>8);SendData(x1 & 0x00FF);
  ~~~~~~~~ ~~^~~
C:/MPLABX_Projects/18F27k42_ RFID_reader_2023.X/main.c:680:14: warning: implicit conversion changes signedness: 'int' to 'uint8_t' (aka 'unsigned char') [-Wsign-conversion]
  SendData(x1>>8);SendData(x1 & 0x00FF);
  ~~~~~~~~ ~~^~~
.......   
                                   ^
C:/MPLABX_Projects/18F27k42_ RFID_reader_2023.X/main.c:1582:36: note: put the semicolon on a separate line to silence this warning
default: Empty
96 warnings generated.
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=18F27K42 -Wl,-Map=dist/default/production/18F27k42__RFID_reader_2023.X.production.map  -DXPRJ_default=default  -Wl,--defsym=__MPLAB_BUILD=1   -mdfp="C:/Users/Paul/.mchp_packs/Microchip/PIC18F-K_DFP/1.6.125/xc8"  -fno-short-double -fno-short-float -memi=wordwrite -O0 -fasmfile -maddrqual=ignore -xassembler-with-cpp -mwarn=-3 -Wa,-a -msummary=-psect,-class,+mem,-hex,-file  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-download -mdefault-config-bits -std=c99 -gdwarf-3 -mstack=compiled:auto:auto:auto      -Wl,--memorysummary,dist/default/production/memoryfile.xml -o dist/default/production/18F27k42__RFID_reader_2023.X.production.elf  build/default/production/_ext/1426725365/RC522_SPI_Hardw.X.p1 build/default/production/_ext/1426725365/main.p1 build/default/production/_ext/1426725365/Config.p1 build/default/production/_ext/1426725365/Init_GC9A01.p1     
::: advisory: (2086) memory for a heap has been reserved in response to the detection of calls to malloc/calloc/realloc/free function(s)

Memory Summary:
    Program space        used  7AB5h ( 31413) of 20000h bytes   ( 24.0%)
    Data space           used   389h (   905) of  2000h bytes   ( 11.0%)
    Configuration bits   used     5h (     5) of     5h words   (100.0%)
    EEPROM space         used     0h (     0) of   400h bytes   (  0.0%)
    ID Location space    used    10h (    16) of    10h bytes   (100.0%)
    Data heap space      used  1C00h (  7168) of  1C00h bytes   (100.0%)

make[2]: Leaving directory 'C:/MPLABX_Projects/18F27k42_ RFID_reader_2023.X'
make[1]: Leaving directory 'C:/MPLABX_Projects/18F27k42_ RFID_reader_2023.X'

BUILD SUCCESSFUL (total time: 8s)
Loading code from C:/MPLABX_Projects/18F27k42_ RFID_reader_2023.X/dist/default/production/18F27k42__RFID_reader_2023.X.production.hex...
Program loaded with pack,PIC18F-K_DFP,1.6.125,Microchip
Loading completed

*****************************************************
Connecting to MPLAB PICkit 4

Currently loaded versions:
Application version...........00.09.46
Boot version..................01.00.00
Script version................00.05.58
Script build number...........abbfe90327
Tool pack version ............1.15.1688
Target voltage detected
Target device PIC18F27K42 found.
Device Revision Id  = 0xa0010000

Erasing...

The following memory area(s) will be programmed:
program memory: start address = 0x0, end address = 0x1ffff
configuration memory
EEData memory
User Id Memory

Programming/Verify complete

 * */